#ifndef INC_LIBNAW_DATA_H
#define INC_LIBNAW_DATA_H

/* XXX: currently ipv4 only */

struct netdata {
    ub4_t bits;  /* netmask */
    ub4_t host;  /* ipv4 address */
    ub4_t port;
    ub4_t pits;  /* port bits/mask (XXX: unimplemented) */
};

struct netinfo {
    struct netdata dst;
    struct netdata src;
};

struct netentry {
    ub1_t action;
    ub1_t padding[3];
    struct netinfo info;
    ub4_t module_key;
};

struct naw_data {
        blobset *bs;
};

struct naw_module {
    void *handle;
    struct naw_modfuncset *f;
};

struct naw_module_dbset {
    ub4_t *modrefp;
    ub4_t modref;
    ub1_t howmany;
};

/* modentry_globals() expects a specific order */
struct naw_handle {
    int sd;
    ub1_t type;
    struct netinfo *info;
    struct netentry *entry;
};

struct naw_modfuncset {
    int  (*accept) (struct naw_handle *, struct naw_data *);
    int  (*connect)(struct naw_handle *, struct naw_data *);
    int  (*init) (struct naw_data *);
    void (*fini) (void);
};

#endif
