#ifndef _LIBNAW_FUNC_H
#define _LIBNAW_FUNC_H

#include <sys/types.h>
#include <netinet/in.h>
#include <minimisc.h>
#include "lxmisc.h"
#include "data.h"

extern void setup_env_opt(void);
extern void setup_flushfile(void);
extern int  module_check_flush(void);
extern void module_reset_flush_counter(void);

extern void *get_funcptr(char *);
extern void naw_init(void);

extern void _init(void);
extern int  naw_verify(int, ub1_t, void *);
extern int  naw_verify_internal(int, ub1_t, void *);
extern char get_addr_data(struct netinfo *, struct sockaddr_in *, char, int);
extern char cmp_host_bits(ub4_t, ub4_t, ub4_t, ub1_t);
extern int  naw_data_init(struct naw_data *);
extern void naw_data_free(struct naw_data *);
extern struct naw_module *naw_module_new (ub1_t *, struct naw_data *);
extern void naw_module_free(void *);
extern void gd_setup(void);

#ifdef TINYCDB_VERSION
# define CDB struct cdb

/* since c is on the stack in this case, we need to
   initialize it to 0 manually */
# define CDB_INIT(c, fd) do { \
    memset (c, 0, sizeof(struct cdb)); \
    cdb_init(c, fd); \
} while(0)
#else
# define CDB void
#endif
extern int  module_call(CDB *, char *, unsigned int, struct naw_handle *,
        struct naw_data *);
extern int module_entry(struct naw_handle *, CDB *);
extern int  naw_data_parse(struct naw_data *, CDB *, char *, unsigned int);
/*
extern int modentry_parse(CDB *, struct naw_data *, struct naw_module_dbset *);
*/
extern int modentry_run(CDB *, struct naw_handle *, struct naw_data *);
extern int submodule (struct naw_handle *, CDB *, ub4_t, struct naw_data *);
extern int modentry_globals(CDB *);


/* dies and logs */
extern void die_dlsym(char *, char *);
extern void die_badenv(char *);
extern void die_noconfig(void);
extern void die_open(char *);
extern void die_nomem(void);
extern void warn_notreadable(char *);
extern void log_err(char *, char *, char *, char *, char *, char *);
extern void log_warn(char *, char *, char *, char *, char *);
extern void log_debug(char, char *, char *, char *, char *, char *);

/* wrappers */
extern void wrap_connect(void);
extern void wrap_accept(void);

#endif
