#include "misc.h"
#include <lx_map.h>
#include "naw.h"
#include "naw_log.h"

/***************************************************************************
  naw_test_module_accept

  takes the place of both 'accept' and 'reject' actions.  Only returns YES,
  so 'deny' actions will result in rejection, and 'accept' actions will
  result in access.
 ***************************************************************************/

static int naw_test_module_accept (handle, data)
    struct naw_handle *handle;
    struct naw_data *data;
{
    char *v;
    int vlen;
    if (!naw_data_get(data, "true", &v, &vlen)) {
        NAW_LOG(NAW_DEBUG, LXM_q("true: "),LXM_mb(v,vlen));
        if (naw_data_set(data, "true", 0, 0))
            NAW_LOG(NAW_NOTICE, LXM_q("couldn't unset 'true'"));
    } else
        naw_data_set(data, "true", "hmmm", 4);

    NAW_LOG(NAW_DEBUG2, LXM_q("true: accepting connection"));
    return NAW_YES;
}

static int naw_test_module_init (data)
    struct naw_data *data;
{
    char *v;
    int vlen;

    NAW_LOG(NAW_DEBUG3, LXM_q("true: loading up"));
    if (!naw_data_get(data, "true", &v, &vlen))
        NAW_LOG(NAW_DEBUG, LXM_q("true.init: "),LXM_mb(v,vlen));
    return NAW_OK;
}

static void naw_test_module_fini (void)
{
    NAW_LOG(NAW_DEBUG3, LXM_q("true: winding down"));
}

struct naw_modfuncset naw_set = {
    naw_test_module_accept,  /* accept  */
    naw_test_module_accept,  /* connect */
    naw_test_module_init,    /* init    */
    naw_test_module_fini,    /* fini    */
};

